/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the OfficeHoursSettings type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &OfficeHoursSettings{}

// OfficeHoursSettings struct for OfficeHoursSettings
type OfficeHoursSettings struct {
	Enabled *bool `json:"enabled,omitempty"`
	MessageWhenClosed *string `json:"message_when_closed,omitempty"`
	MessageWhenOpened *string `json:"message_when_opened,omitempty"`
	Monday []WorkingTime `json:"monday,omitempty"`
	Tuesday []WorkingTime `json:"tuesday,omitempty"`
	Wednesday []WorkingTime `json:"wednesday,omitempty"`
	Thursday []WorkingTime `json:"thursday,omitempty"`
	Friday []WorkingTime `json:"friday,omitempty"`
	Saturday []WorkingTime `json:"saturday,omitempty"`
	Sunday []WorkingTime `json:"sunday,omitempty"`
}

// NewOfficeHoursSettings instantiates a new OfficeHoursSettings object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewOfficeHoursSettings() *OfficeHoursSettings {
	this := OfficeHoursSettings{}
	return &this
}

// NewOfficeHoursSettingsWithDefaults instantiates a new OfficeHoursSettings object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewOfficeHoursSettingsWithDefaults() *OfficeHoursSettings {
	this := OfficeHoursSettings{}
	return &this
}

// GetEnabled returns the Enabled field value if set, zero value otherwise.
func (o *OfficeHoursSettings) GetEnabled() bool {
	if o == nil || IsNil(o.Enabled) {
		var ret bool
		return ret
	}
	return *o.Enabled
}

// GetEnabledOk returns a tuple with the Enabled field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OfficeHoursSettings) GetEnabledOk() (*bool, bool) {
	if o == nil || IsNil(o.Enabled) {
		return nil, false
	}
	return o.Enabled, true
}

// HasEnabled returns a boolean if a field has been set.
func (o *OfficeHoursSettings) HasEnabled() bool {
	if o != nil && !IsNil(o.Enabled) {
		return true
	}

	return false
}

// SetEnabled gets a reference to the given bool and assigns it to the Enabled field.
func (o *OfficeHoursSettings) SetEnabled(v bool) {
	o.Enabled = &v
}

// GetMessageWhenClosed returns the MessageWhenClosed field value if set, zero value otherwise.
func (o *OfficeHoursSettings) GetMessageWhenClosed() string {
	if o == nil || IsNil(o.MessageWhenClosed) {
		var ret string
		return ret
	}
	return *o.MessageWhenClosed
}

// GetMessageWhenClosedOk returns a tuple with the MessageWhenClosed field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OfficeHoursSettings) GetMessageWhenClosedOk() (*string, bool) {
	if o == nil || IsNil(o.MessageWhenClosed) {
		return nil, false
	}
	return o.MessageWhenClosed, true
}

// HasMessageWhenClosed returns a boolean if a field has been set.
func (o *OfficeHoursSettings) HasMessageWhenClosed() bool {
	if o != nil && !IsNil(o.MessageWhenClosed) {
		return true
	}

	return false
}

// SetMessageWhenClosed gets a reference to the given string and assigns it to the MessageWhenClosed field.
func (o *OfficeHoursSettings) SetMessageWhenClosed(v string) {
	o.MessageWhenClosed = &v
}

// GetMessageWhenOpened returns the MessageWhenOpened field value if set, zero value otherwise.
func (o *OfficeHoursSettings) GetMessageWhenOpened() string {
	if o == nil || IsNil(o.MessageWhenOpened) {
		var ret string
		return ret
	}
	return *o.MessageWhenOpened
}

// GetMessageWhenOpenedOk returns a tuple with the MessageWhenOpened field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OfficeHoursSettings) GetMessageWhenOpenedOk() (*string, bool) {
	if o == nil || IsNil(o.MessageWhenOpened) {
		return nil, false
	}
	return o.MessageWhenOpened, true
}

// HasMessageWhenOpened returns a boolean if a field has been set.
func (o *OfficeHoursSettings) HasMessageWhenOpened() bool {
	if o != nil && !IsNil(o.MessageWhenOpened) {
		return true
	}

	return false
}

// SetMessageWhenOpened gets a reference to the given string and assigns it to the MessageWhenOpened field.
func (o *OfficeHoursSettings) SetMessageWhenOpened(v string) {
	o.MessageWhenOpened = &v
}

// GetMonday returns the Monday field value if set, zero value otherwise.
func (o *OfficeHoursSettings) GetMonday() []WorkingTime {
	if o == nil || IsNil(o.Monday) {
		var ret []WorkingTime
		return ret
	}
	return o.Monday
}

// GetMondayOk returns a tuple with the Monday field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OfficeHoursSettings) GetMondayOk() ([]WorkingTime, bool) {
	if o == nil || IsNil(o.Monday) {
		return nil, false
	}
	return o.Monday, true
}

// HasMonday returns a boolean if a field has been set.
func (o *OfficeHoursSettings) HasMonday() bool {
	if o != nil && !IsNil(o.Monday) {
		return true
	}

	return false
}

// SetMonday gets a reference to the given []WorkingTime and assigns it to the Monday field.
func (o *OfficeHoursSettings) SetMonday(v []WorkingTime) {
	o.Monday = v
}

// GetTuesday returns the Tuesday field value if set, zero value otherwise.
func (o *OfficeHoursSettings) GetTuesday() []WorkingTime {
	if o == nil || IsNil(o.Tuesday) {
		var ret []WorkingTime
		return ret
	}
	return o.Tuesday
}

// GetTuesdayOk returns a tuple with the Tuesday field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OfficeHoursSettings) GetTuesdayOk() ([]WorkingTime, bool) {
	if o == nil || IsNil(o.Tuesday) {
		return nil, false
	}
	return o.Tuesday, true
}

// HasTuesday returns a boolean if a field has been set.
func (o *OfficeHoursSettings) HasTuesday() bool {
	if o != nil && !IsNil(o.Tuesday) {
		return true
	}

	return false
}

// SetTuesday gets a reference to the given []WorkingTime and assigns it to the Tuesday field.
func (o *OfficeHoursSettings) SetTuesday(v []WorkingTime) {
	o.Tuesday = v
}

// GetWednesday returns the Wednesday field value if set, zero value otherwise.
func (o *OfficeHoursSettings) GetWednesday() []WorkingTime {
	if o == nil || IsNil(o.Wednesday) {
		var ret []WorkingTime
		return ret
	}
	return o.Wednesday
}

// GetWednesdayOk returns a tuple with the Wednesday field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OfficeHoursSettings) GetWednesdayOk() ([]WorkingTime, bool) {
	if o == nil || IsNil(o.Wednesday) {
		return nil, false
	}
	return o.Wednesday, true
}

// HasWednesday returns a boolean if a field has been set.
func (o *OfficeHoursSettings) HasWednesday() bool {
	if o != nil && !IsNil(o.Wednesday) {
		return true
	}

	return false
}

// SetWednesday gets a reference to the given []WorkingTime and assigns it to the Wednesday field.
func (o *OfficeHoursSettings) SetWednesday(v []WorkingTime) {
	o.Wednesday = v
}

// GetThursday returns the Thursday field value if set, zero value otherwise.
func (o *OfficeHoursSettings) GetThursday() []WorkingTime {
	if o == nil || IsNil(o.Thursday) {
		var ret []WorkingTime
		return ret
	}
	return o.Thursday
}

// GetThursdayOk returns a tuple with the Thursday field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OfficeHoursSettings) GetThursdayOk() ([]WorkingTime, bool) {
	if o == nil || IsNil(o.Thursday) {
		return nil, false
	}
	return o.Thursday, true
}

// HasThursday returns a boolean if a field has been set.
func (o *OfficeHoursSettings) HasThursday() bool {
	if o != nil && !IsNil(o.Thursday) {
		return true
	}

	return false
}

// SetThursday gets a reference to the given []WorkingTime and assigns it to the Thursday field.
func (o *OfficeHoursSettings) SetThursday(v []WorkingTime) {
	o.Thursday = v
}

// GetFriday returns the Friday field value if set, zero value otherwise.
func (o *OfficeHoursSettings) GetFriday() []WorkingTime {
	if o == nil || IsNil(o.Friday) {
		var ret []WorkingTime
		return ret
	}
	return o.Friday
}

// GetFridayOk returns a tuple with the Friday field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OfficeHoursSettings) GetFridayOk() ([]WorkingTime, bool) {
	if o == nil || IsNil(o.Friday) {
		return nil, false
	}
	return o.Friday, true
}

// HasFriday returns a boolean if a field has been set.
func (o *OfficeHoursSettings) HasFriday() bool {
	if o != nil && !IsNil(o.Friday) {
		return true
	}

	return false
}

// SetFriday gets a reference to the given []WorkingTime and assigns it to the Friday field.
func (o *OfficeHoursSettings) SetFriday(v []WorkingTime) {
	o.Friday = v
}

// GetSaturday returns the Saturday field value if set, zero value otherwise.
func (o *OfficeHoursSettings) GetSaturday() []WorkingTime {
	if o == nil || IsNil(o.Saturday) {
		var ret []WorkingTime
		return ret
	}
	return o.Saturday
}

// GetSaturdayOk returns a tuple with the Saturday field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OfficeHoursSettings) GetSaturdayOk() ([]WorkingTime, bool) {
	if o == nil || IsNil(o.Saturday) {
		return nil, false
	}
	return o.Saturday, true
}

// HasSaturday returns a boolean if a field has been set.
func (o *OfficeHoursSettings) HasSaturday() bool {
	if o != nil && !IsNil(o.Saturday) {
		return true
	}

	return false
}

// SetSaturday gets a reference to the given []WorkingTime and assigns it to the Saturday field.
func (o *OfficeHoursSettings) SetSaturday(v []WorkingTime) {
	o.Saturday = v
}

// GetSunday returns the Sunday field value if set, zero value otherwise.
func (o *OfficeHoursSettings) GetSunday() []WorkingTime {
	if o == nil || IsNil(o.Sunday) {
		var ret []WorkingTime
		return ret
	}
	return o.Sunday
}

// GetSundayOk returns a tuple with the Sunday field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OfficeHoursSettings) GetSundayOk() ([]WorkingTime, bool) {
	if o == nil || IsNil(o.Sunday) {
		return nil, false
	}
	return o.Sunday, true
}

// HasSunday returns a boolean if a field has been set.
func (o *OfficeHoursSettings) HasSunday() bool {
	if o != nil && !IsNil(o.Sunday) {
		return true
	}

	return false
}

// SetSunday gets a reference to the given []WorkingTime and assigns it to the Sunday field.
func (o *OfficeHoursSettings) SetSunday(v []WorkingTime) {
	o.Sunday = v
}

func (o OfficeHoursSettings) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o OfficeHoursSettings) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Enabled) {
		toSerialize["enabled"] = o.Enabled
	}
	if !IsNil(o.MessageWhenClosed) {
		toSerialize["message_when_closed"] = o.MessageWhenClosed
	}
	if !IsNil(o.MessageWhenOpened) {
		toSerialize["message_when_opened"] = o.MessageWhenOpened
	}
	if !IsNil(o.Monday) {
		toSerialize["monday"] = o.Monday
	}
	if !IsNil(o.Tuesday) {
		toSerialize["tuesday"] = o.Tuesday
	}
	if !IsNil(o.Wednesday) {
		toSerialize["wednesday"] = o.Wednesday
	}
	if !IsNil(o.Thursday) {
		toSerialize["thursday"] = o.Thursday
	}
	if !IsNil(o.Friday) {
		toSerialize["friday"] = o.Friday
	}
	if !IsNil(o.Saturday) {
		toSerialize["saturday"] = o.Saturday
	}
	if !IsNil(o.Sunday) {
		toSerialize["sunday"] = o.Sunday
	}
	return toSerialize, nil
}

type NullableOfficeHoursSettings struct {
	value *OfficeHoursSettings
	isSet bool
}

func (v NullableOfficeHoursSettings) Get() *OfficeHoursSettings {
	return v.value
}

func (v *NullableOfficeHoursSettings) Set(val *OfficeHoursSettings) {
	v.value = val
	v.isSet = true
}

func (v NullableOfficeHoursSettings) IsSet() bool {
	return v.isSet
}

func (v *NullableOfficeHoursSettings) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableOfficeHoursSettings(val *OfficeHoursSettings) *NullableOfficeHoursSettings {
	return &NullableOfficeHoursSettings{value: val, isSet: true}
}

func (v NullableOfficeHoursSettings) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableOfficeHoursSettings) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


